package com.loafle.overflow.rpc;

import com.loafle.overflow.crawler.Crawler;
import com.loafle.overflow.rpc.api.RemoteImpl;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static org.junit.Assert.*;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = Application.class)
public class ApplicationTest {

    @Autowired
    private RemoteImpl impl;

    @Test
    public void TestRun() throws Exception {

        Crawler r = impl.getCrawler("REDIS");
        Map<String,Object> m= new HashMap<String, Object>();
        m.put("id","192.168.1.104");
        m.put("port","6379");
        r.putConfig("testid",m);

        m = r.getConfig("testid");
        assertEquals("192.168.1.104",m.get("id"));
    }

    @Test
    public void testWMI() throws Exception {
        Crawler r = impl.getCrawler("WMI");

        Map<String, Object> map = new HashMap<String, Object>();

        map.put("id", "administrator");
        map.put("pw", "!@#$qwer1234");
        map.put("nameSpace", "root/cimv2");
        map.put("query", "select * from Win32_OperatingSystem");
        map.put("ip", "192.168.1.1");

        List<Map<String, String>> resultList =  (List<Map<String, String>>)r.getInternal(map);

        for( Map<String,String> rMap : resultList) {
            for( String key : rMap.keySet() ){
                System.out.println( String.format("key : %s ||| value : %s", key, rMap.get(key)) );
            }
        }

    }
}